import type { RenderingPlugin, RenderingService } from '@antv/g';
/**
 * support 2 modes in rendering:
 * * immediate
 * * delayed: render at the end of frame with dirty-rectangle
 */
export declare class CanvasRendererPlugin implements RenderingPlugin {
    static tag: string;
    private canvasConfig;
    private camera;
    private contextService;
    private renderingContext;
    private pathGeneratorFactory;
    private pathGeneratorFactoryCache;
    private styleRendererFactory;
    private styleRendererFactoryCache;
    private displayObjectPool;
    /**
     * RBush used in dirty rectangle rendering
     */
    private rBush;
    private removedRBushNodeAABBs;
    private renderQueue;
    private restoreStack;
    private clearFullScreen;
    /**
     * view projection matrix
     */
    private vpMatrix;
    private dprMatrix;
    private tmpMat4;
    private tmpVec3;
    apply(renderingService: RenderingService): void;
    private clearRect;
    private renderDisplayObject;
    private convertAABB2Rect;
    /**
     * TODO: merge dirty rectangles with some strategies.
     * For now, we just simply merge all the rectangles into one.
     * @see https://idom.me/articles/841.html
     */
    private mergeDirtyAABBs;
    private searchDirtyObjects;
    private saveDirtyAABB;
    /**
     * TODO: batch the same global attributes
     */
    private applyAttributesToContext;
    private applyWorldTransform;
    private safeMergeAABB;
}
//# sourceMappingURL=CanvasRendererPlugin.d.ts.map