import { Syringe, isString, inject, singleton, UnitType, isNil, isPattern, GradientType, CanvasConfig, DefaultCamera, Camera, ContextService, RenderingContext, DisplayObjectPool, RBushRoot, RBush, RenderingPluginContribution, ElementEvent, AABB, Shape, Module } from '@antv/g';
import { __decorate, __metadata } from 'tslib';
import { PathGeneratorFactory } from '@antv/g-plugin-canvas-path-generator';
import { ImagePool } from '@antv/g-plugin-image-loader';

function _regeneratorRuntime() {
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

  _regeneratorRuntime = function () {
    return exports;
  };

  var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }

  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");

        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }

        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);

          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }

          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  exports.wrap = wrap;
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if ("throw" !== record.type) {
        var result = record.arg,
            value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }

      reject(record.arg);
    }

    var previousPromise;

    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;

          return next.value = undefined, next.done = !0, next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }

  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];

    for (var key in object) keys.push(key);

    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }

      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;

      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
            record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

/**
 * Common utilities
 * @module glMatrix
 */
var ARRAY_TYPE = typeof Float32Array !== 'undefined' ? Float32Array : Array;
if (!Math.hypot) Math.hypot = function () {
  var y = 0,
      i = arguments.length;

  while (i--) {
    y += arguments[i] * arguments[i];
  }

  return Math.sqrt(y);
};

/**
 * 4x4 Matrix<br>Format: column-major, when typed out it looks like row-major<br>The matrices are being post multiplied.
 * @module mat4
 */

/**
 * Creates a new identity mat4
 *
 * @returns {mat4} a new 4x4 matrix
 */

function create() {
  var out = new ARRAY_TYPE(16);

  if (ARRAY_TYPE != Float32Array) {
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
  }

  out[0] = 1;
  out[5] = 1;
  out[10] = 1;
  out[15] = 1;
  return out;
}
/**
 * Copy the values from one mat4 to another
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the source matrix
 * @returns {mat4} out
 */

function copy(out, a) {
  out[0] = a[0];
  out[1] = a[1];
  out[2] = a[2];
  out[3] = a[3];
  out[4] = a[4];
  out[5] = a[5];
  out[6] = a[6];
  out[7] = a[7];
  out[8] = a[8];
  out[9] = a[9];
  out[10] = a[10];
  out[11] = a[11];
  out[12] = a[12];
  out[13] = a[13];
  out[14] = a[14];
  out[15] = a[15];
  return out;
}
/**
 * Multiplies two mat4s
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the first operand
 * @param {ReadonlyMat4} b the second operand
 * @returns {mat4} out
 */

function multiply(out, a, b) {
  var a00 = a[0],
      a01 = a[1],
      a02 = a[2],
      a03 = a[3];
  var a10 = a[4],
      a11 = a[5],
      a12 = a[6],
      a13 = a[7];
  var a20 = a[8],
      a21 = a[9],
      a22 = a[10],
      a23 = a[11];
  var a30 = a[12],
      a31 = a[13],
      a32 = a[14],
      a33 = a[15]; // Cache only the current line of the second matrix

  var b0 = b[0],
      b1 = b[1],
      b2 = b[2],
      b3 = b[3];
  out[0] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
  out[1] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
  out[2] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
  out[3] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
  b0 = b[4];
  b1 = b[5];
  b2 = b[6];
  b3 = b[7];
  out[4] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
  out[5] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
  out[6] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
  out[7] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
  b0 = b[8];
  b1 = b[9];
  b2 = b[10];
  b3 = b[11];
  out[8] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
  out[9] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
  out[10] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
  out[11] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
  b0 = b[12];
  b1 = b[13];
  b2 = b[14];
  b3 = b[15];
  out[12] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
  out[13] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
  out[14] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
  out[15] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
  return out;
}
/**
 * Translate a mat4 by the given vector
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to translate
 * @param {ReadonlyVec3} v vector to translate by
 * @returns {mat4} out
 */

function translate(out, a, v) {
  var x = v[0],
      y = v[1],
      z = v[2];
  var a00, a01, a02, a03;
  var a10, a11, a12, a13;
  var a20, a21, a22, a23;

  if (a === out) {
    out[12] = a[0] * x + a[4] * y + a[8] * z + a[12];
    out[13] = a[1] * x + a[5] * y + a[9] * z + a[13];
    out[14] = a[2] * x + a[6] * y + a[10] * z + a[14];
    out[15] = a[3] * x + a[7] * y + a[11] * z + a[15];
  } else {
    a00 = a[0];
    a01 = a[1];
    a02 = a[2];
    a03 = a[3];
    a10 = a[4];
    a11 = a[5];
    a12 = a[6];
    a13 = a[7];
    a20 = a[8];
    a21 = a[9];
    a22 = a[10];
    a23 = a[11];
    out[0] = a00;
    out[1] = a01;
    out[2] = a02;
    out[3] = a03;
    out[4] = a10;
    out[5] = a11;
    out[6] = a12;
    out[7] = a13;
    out[8] = a20;
    out[9] = a21;
    out[10] = a22;
    out[11] = a23;
    out[12] = a00 * x + a10 * y + a20 * z + a[12];
    out[13] = a01 * x + a11 * y + a21 * z + a[13];
    out[14] = a02 * x + a12 * y + a22 * z + a[14];
    out[15] = a03 * x + a13 * y + a23 * z + a[15];
  }

  return out;
}
/**
 * Creates a matrix from a vector scaling
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.scale(dest, dest, vec);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {ReadonlyVec3} v Scaling vector
 * @returns {mat4} out
 */

function fromScaling(out, v) {
  out[0] = v[0];
  out[1] = 0;
  out[2] = 0;
  out[3] = 0;
  out[4] = 0;
  out[5] = v[1];
  out[6] = 0;
  out[7] = 0;
  out[8] = 0;
  out[9] = 0;
  out[10] = v[2];
  out[11] = 0;
  out[12] = 0;
  out[13] = 0;
  out[14] = 0;
  out[15] = 1;
  return out;
}

/**
 * 3 Dimensional Vector
 * @module vec3
 */

/**
 * Creates a new, empty vec3
 *
 * @returns {vec3} a new 3D vector
 */

function create$1() {
  var out = new ARRAY_TYPE(3);

  if (ARRAY_TYPE != Float32Array) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
  }

  return out;
}
/**
 * Creates a new vec3 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @returns {vec3} a new 3D vector
 */

function fromValues(x, y, z) {
  var out = new ARRAY_TYPE(3);
  out[0] = x;
  out[1] = y;
  out[2] = z;
  return out;
}
/**
 * Perform some operation over an array of vec3s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec3. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec3s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */

var forEach = function () {
  var vec = create$1();
  return function (a, stride, offset, count, fn, arg) {
    var i, l;

    if (!stride) {
      stride = 3;
    }

    if (!offset) {
      offset = 0;
    }

    if (count) {
      l = Math.min(count * stride + offset, a.length);
    } else {
      l = a.length;
    }

    for (i = offset; i < l; i += stride) {
      vec[0] = a[i];
      vec[1] = a[i + 1];
      vec[2] = a[i + 2];
      fn(vec, vec, arg);
      a[i] = vec[0];
      a[i + 1] = vec[1];
      a[i + 2] = vec[2];
    }

    return a;
  };
}();

var StyleRendererFactory = Syringe.defineToken('StyleRendererFactory');
var CircleRendererContribution = Syringe.defineToken('CircleRenderer', {
  multiple: false
});
var EllipseRendererContribution = Syringe.defineToken('EllipseRenderer', {
  multiple: false
});
var RectRendererContribution = Syringe.defineToken('RectRenderer', {
  multiple: false
});
var LineRendererContribution = Syringe.defineToken('LineRenderer', {
  multiple: false
});
var PolylineRendererContribution = Syringe.defineToken('PolylineRenderer', {
  multiple: false
});
var PolygonRendererContribution = Syringe.defineToken('PolygonRenderer', {
  multiple: false
});
var PathRendererContribution = Syringe.defineToken('PathRenderer', {
  multiple: false
});
var TextRendererContribution = Syringe.defineToken('TextRenderer', {
  multiple: false
});
var ImageRendererContribution = Syringe.defineToken('ImageRenderer', {
  multiple: false
});

var ImageRenderer = /*#__PURE__*/function () {
  function ImageRenderer() {
    this.imagePool = void 0;
  }

  var _proto = ImageRenderer.prototype;

  _proto.render = function render(context, parsedStyle) {
    var width = parsedStyle.width,
        height = parsedStyle.height,
        img = parsedStyle.img;
    var image;
    var iw = width.value;
    var ih = height.value;

    if (isString(img)) {
      // image has been loaded in `mounted` hook
      image = this.imagePool.getImageSync(img);
    } else {
      iw || (iw = img.width);
      ih || (ih = img.height);
      image = img;
    }

    if (image) {
      // node-canvas will throw the following err:
      // Error: Image given has not completed loading
      try {
        context.drawImage(image, 0, 0, iw, ih);
      } catch (e) {}
    }
  };

  return ImageRenderer;
}();

__decorate([inject(ImagePool), __metadata("design:type", ImagePool)], ImageRenderer.prototype, "imagePool", void 0);

ImageRenderer = __decorate([singleton({
  token: ImageRendererContribution
})], ImageRenderer);

var TextRenderer = /*#__PURE__*/function () {
  function TextRenderer() {}

  var _proto = TextRenderer.prototype;

  _proto.render = function render(context, parsedStyle, object) {
    var lineWidth = parsedStyle.lineWidth,
        textAlign = parsedStyle.textAlign,
        textBaseline = parsedStyle.textBaseline,
        lineJoin = parsedStyle.lineJoin,
        _parsedStyle$miterLim = parsedStyle.miterLimit,
        miterLimit = _parsedStyle$miterLim === void 0 ? 0 : _parsedStyle$miterLim,
        _parsedStyle$letterSp = parsedStyle.letterSpacing,
        letterSpacing = _parsedStyle$letterSp === void 0 ? 0 : _parsedStyle$letterSp,
        stroke = parsedStyle.stroke,
        fill = parsedStyle.fill,
        fillOpacity = parsedStyle.fillOpacity,
        strokeOpacity = parsedStyle.strokeOpacity,
        opacity = parsedStyle.opacity,
        metrics = parsedStyle.metrics,
        dx = parsedStyle.dx,
        dy = parsedStyle.dy;
    var font = metrics.font,
        lines = metrics.lines,
        height = metrics.height,
        lineHeight = metrics.lineHeight,
        lineMetrics = metrics.lineMetrics;
    context.font = font;
    context.lineWidth = lineWidth.value;
    context.textAlign = textAlign.value;
    context.textBaseline = textBaseline.value;
    context.lineJoin = lineJoin.value;
    context.miterLimit = miterLimit;
    var linePositionY = 0; // handle vertical text baseline

    if (textBaseline.value === 'middle') {
      linePositionY = -height / 2 - lineHeight / 2;
    } else if (textBaseline.value === 'bottom' || textBaseline.value === 'alphabetic' || textBaseline.value === 'ideographic') {
      linePositionY = -height;
    } else if (textBaseline.value === 'top' || textBaseline.value === 'hanging') {
      linePositionY = -lineHeight;
    } // account for dx & dy


    var offsetX = 0;

    if (dx && dx.unit === UnitType.kPixels) {
      offsetX += dx.value;
    }

    if (dy && dy.unit === UnitType.kPixels) {
      linePositionY += dy.value;
    } // draw lines line by line


    for (var i = 0; i < lines.length; i++) {
      var linePositionX = lineWidth.value / 2 + offsetX;
      linePositionY += lineHeight; // no need to re-position X, cause we already set text align
      // @see https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/textAlign

      if (!isNil(stroke) && !stroke.isNone && lineWidth && lineWidth.value) {
        this.drawLetterSpacing(context, lines[i], lineMetrics[i], textAlign.value, linePositionX, linePositionY, letterSpacing, fillOpacity.value, strokeOpacity.value, opacity.value, true);
      }

      if (!isNil(fill)) {
        this.drawLetterSpacing(context, lines[i], lineMetrics[i], textAlign.value, linePositionX, linePositionY, letterSpacing, fillOpacity.value, strokeOpacity.value, opacity.value);
      }
    }
  };

  _proto.drawLetterSpacing = function drawLetterSpacing(context, text, lineMetrics, textAlign, x, y, letterSpacing, fillOpacity, strokeOpacity, opacity, isStroke) {
    if (isStroke === void 0) {
      isStroke = false;
    }

    // letterSpacing of 0 means normal, render all texts directly
    if (letterSpacing === 0) {
      if (isStroke) {
        this.strokeText(context, text, x, y, strokeOpacity);
      } else {
        this.fillText(context, text, x, y, fillOpacity, opacity);
      }

      return;
    } // draw text using left align


    var currentTextAlign = context.textAlign;
    context.textAlign = 'left';
    var currentPosition = x;

    if (textAlign === 'center') {
      currentPosition = x - lineMetrics.width / 2;
    } else if (textAlign === 'right' || textAlign === 'end') {
      currentPosition = x - lineMetrics.width;
    }

    var stringArray = Array.from(text);
    var previousWidth = context.measureText(text).width;
    var currentWidth = 0;

    for (var i = 0; i < stringArray.length; ++i) {
      var currentChar = stringArray[i];

      if (isStroke) {
        this.strokeText(context, currentChar, currentPosition, y, strokeOpacity);
      } else {
        this.fillText(context, currentChar, currentPosition, y, fillOpacity, opacity);
      }

      currentWidth = context.measureText(text.substring(i + 1)).width;
      currentPosition += previousWidth - currentWidth + letterSpacing;
      previousWidth = currentWidth;
    }

    context.textAlign = currentTextAlign;
  };

  _proto.fillText = function fillText(context, text, x, y, fillOpacity, opacity) {
    var currentGlobalAlpha;
    var applyOpacity = !isNil(fillOpacity) && fillOpacity !== 1;

    if (applyOpacity) {
      currentGlobalAlpha = context.globalAlpha;
      context.globalAlpha = fillOpacity * opacity;
    }

    context.fillText(text, x, y);

    if (applyOpacity) {
      context.globalAlpha = currentGlobalAlpha;
    }
  };

  _proto.strokeText = function strokeText(context, text, x, y, strokeOpacity) {
    var currentGlobalAlpha;
    var applyOpacity = !isNil(strokeOpacity) && strokeOpacity !== 1;

    if (applyOpacity) {
      currentGlobalAlpha = context.globalAlpha;
      context.globalAlpha = strokeOpacity;
    }

    context.strokeText(text, x, y);

    if (applyOpacity) {
      context.globalAlpha = currentGlobalAlpha;
    }
  };

  return TextRenderer;
}();

TextRenderer = __decorate([singleton({
  token: TextRendererContribution
})], TextRenderer);

var DefaultRenderer = /*#__PURE__*/function () {
  function DefaultRenderer() {
    this.imagePool = void 0;
  }

  var _proto = DefaultRenderer.prototype;

  _proto.render = function render(context, parsedStyle, object, renderingService) {
    var fill = parsedStyle.fill,
        opacity = parsedStyle.opacity,
        fillOpacity = parsedStyle.fillOpacity,
        stroke = parsedStyle.stroke,
        strokeOpacity = parsedStyle.strokeOpacity,
        lineWidth = parsedStyle.lineWidth,
        lineCap = parsedStyle.lineCap,
        lineJoin = parsedStyle.lineJoin,
        shadowColor = parsedStyle.shadowColor,
        filter = parsedStyle.filter,
        miterLimit = parsedStyle.miterLimit;
    var hasFill = !isNil(fill) && !fill.isNone;
    var hasStroke = !isNil(stroke) && !stroke.isNone;
    var isFillTransparent = fill.alpha === 0;

    if (hasFill) {
      if (!isNil(fillOpacity) && fillOpacity.value !== 1) {
        context.globalAlpha = fillOpacity.value;
        this.fill(context, object, fill, renderingService);
        context.globalAlpha = opacity.value;
      } else {
        this.fill(context, object, fill, renderingService);
      }
    }

    if (hasStroke) {
      if (lineWidth && lineWidth.value > 0) {
        var applyOpacity = !isNil(strokeOpacity) && strokeOpacity.value !== 1;

        if (applyOpacity) {
          context.globalAlpha = strokeOpacity.value;
        }

        context.lineWidth = lineWidth.value;

        if (!isNil(miterLimit)) {
          context.miterLimit = miterLimit;
        }

        if (!isNil(lineCap)) {
          context.lineCap = lineCap.value;
        }

        if (!isNil(lineJoin)) {
          context.lineJoin = lineJoin.value;
        }

        var oldShadowBlur;
        var oldShadowColor;
        var oldFilter;
        var hasShadowColor = !isNil(shadowColor);
        var hasFilter = !isNil(filter);

        if (hasShadowColor) {
          // prevent inner shadow when drawing stroke, toggle shadowBlur & filter(drop-shadow)
          // save shadow blur
          oldShadowBlur = context.shadowBlur;
          oldShadowColor = context.shadowColor;

          if (!isNil(oldShadowBlur)) {
            context.shadowColor = 'transparent';
            context.shadowBlur = 0;
          }
        }

        if (hasFilter) {
          // save drop-shadow filter
          oldFilter = context.filter;

          if (!isNil(oldFilter) && oldFilter.indexOf('drop-shadow') > -1) {
            context.filter = oldFilter.replace(/drop-shadow\([^)]*\)/, '').trim() || 'none';
          }
        }

        var drawStroke = hasFill && !isFillTransparent;

        if (drawStroke) {
          this.stroke(context, object, stroke, renderingService);
        } // restore shadow blur


        if (hasShadowColor) {
          context.shadowColor = oldShadowColor;
          context.shadowBlur = oldShadowBlur;
        } // restore filters


        if (hasFilter) {
          context.filter = oldFilter;
        }

        if (!drawStroke) {
          this.stroke(context, object, stroke, renderingService);
        }
      }
    }
  };

  _proto.fill = function fill(context, object, _fill, renderingService) {
    var _this = this;

    if (Array.isArray(_fill)) {
      _fill.forEach(function (gradient) {
        context.fillStyle = _this.getColor(gradient, object, context);
        context.fill();
      });
    } else {
      if (isPattern(_fill)) {
        context.fillStyle = this.getPattern(_fill, object, context, renderingService);
      }

      context.fill();
    }
  };

  _proto.stroke = function stroke(context, object, _stroke, renderingService) {
    var _this2 = this;

    if (Array.isArray(_stroke)) {
      _stroke.forEach(function (gradient) {
        context.strokeStyle = _this2.getColor(gradient, object, context);
        context.stroke();
      });
    } else {
      if (isPattern(_stroke)) {
        context.strokeStyle = this.getPattern(_stroke, object, context, renderingService);
      }

      context.stroke();
    }
  };

  _proto.getPattern = function getPattern(pattern, object, context, renderingService) {
    var canvasPattern = this.imagePool.getOrCreatePatternSync(pattern, context, function () {
      // set dirty rectangle flag
      object.renderable.dirty = true;
      renderingService.dirtify();
    });
    return canvasPattern;
  };

  _proto.getColor = function getColor(parsedColor, object, context) {
    var color;

    if (parsedColor.type === GradientType.LinearGradient || parsedColor.type === GradientType.RadialGradient) {
      var bounds = object.getGeometryBounds();
      var width = bounds && bounds.halfExtents[0] * 2 || 1;
      var height = bounds && bounds.halfExtents[1] * 2 || 1;
      color = this.imagePool.getOrCreateGradient(_extends({
        type: parsedColor.type
      }, parsedColor.value, {
        width: width,
        height: height
      }), context);
    }

    return color;
  };

  return DefaultRenderer;
}();

__decorate([inject(ImagePool), __metadata("design:type", ImagePool)], DefaultRenderer.prototype, "imagePool", void 0);

DefaultRenderer = __decorate([singleton()], DefaultRenderer);

var RectRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(RectRenderer, _DefaultRenderer);

  function RectRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return RectRenderer;
}(DefaultRenderer);

RectRenderer = __decorate([singleton({
  token: RectRendererContribution
})], RectRenderer);

var CircleRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(CircleRenderer, _DefaultRenderer);

  function CircleRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return CircleRenderer;
}(DefaultRenderer);

CircleRenderer = __decorate([singleton({
  token: CircleRendererContribution
})], CircleRenderer);

var EllipseRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(EllipseRenderer, _DefaultRenderer);

  function EllipseRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return EllipseRenderer;
}(DefaultRenderer);

EllipseRenderer = __decorate([singleton({
  token: EllipseRendererContribution
})], EllipseRenderer);

var LineRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(LineRenderer, _DefaultRenderer);

  function LineRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return LineRenderer;
}(DefaultRenderer);

LineRenderer = __decorate([singleton({
  token: LineRendererContribution
})], LineRenderer);

var PolylineRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(PolylineRenderer, _DefaultRenderer);

  function PolylineRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return PolylineRenderer;
}(DefaultRenderer);

PolylineRenderer = __decorate([singleton({
  token: PolylineRendererContribution
})], PolylineRenderer);

var PolygonRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(PolygonRenderer, _DefaultRenderer);

  function PolygonRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return PolygonRenderer;
}(DefaultRenderer);

PolygonRenderer = __decorate([singleton({
  token: PolygonRendererContribution
})], PolygonRenderer);

var PathRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(PathRenderer, _DefaultRenderer);

  function PathRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return PathRenderer;
}(DefaultRenderer);

PathRenderer = __decorate([singleton({
  token: PathRendererContribution
})], PathRenderer);

var _class;

var CanvasRendererPlugin_1;
/**
 * support 2 modes in rendering:
 * * immediate
 * * delayed: render at the end of frame with dirty-rectangle
 */

var CanvasRendererPlugin = CanvasRendererPlugin_1 = (_class = /*#__PURE__*/function () {
  function CanvasRendererPlugin() {
    this.canvasConfig = void 0;
    this.camera = void 0;
    this.contextService = void 0;
    this.renderingContext = void 0;
    this.pathGeneratorFactory = void 0;
    this.pathGeneratorFactoryCache = {};
    this.styleRendererFactory = void 0;
    this.styleRendererFactoryCache = {};
    this.displayObjectPool = void 0;
    this.rBush = void 0;
    this.removedRBushNodeAABBs = [];
    this.renderQueue = [];
    this.restoreStack = [];
    this.clearFullScreen = false;
    this.vpMatrix = create();
    this.dprMatrix = create();
    this.tmpMat4 = create();
    this.tmpVec3 = create$1();
  }

  var _proto = CanvasRendererPlugin.prototype;

  _proto.apply = function apply(renderingService) {
    var _this = this;

    var handleUnmounted = function handleUnmounted(e) {
      var object = e.target; // remove r-bush node
      // @ts-ignore

      var rBushNode = object.rBushNode;

      if (rBushNode.aabb) {
        // save removed aabbs for dirty-rectangle rendering later
        _this.removedRBushNodeAABBs.push(rBushNode.aabb);
      }
    };

    var handleCulled = function handleCulled(e) {
      var object = e.target; // @ts-ignore

      var rBushNode = object.rBushNode;

      if (rBushNode.aabb) {
        // save removed aabbs for dirty-rectangle rendering later
        _this.removedRBushNodeAABBs.push(rBushNode.aabb);
      }
    };

    renderingService.hooks.init.tapPromise(CanvasRendererPlugin_1.tag, /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var dpr, _this$canvasConfig, width, height, context;

      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this.renderingContext.root.addEventListener(ElementEvent.UNMOUNTED, handleUnmounted);

              _this.renderingContext.root.addEventListener(ElementEvent.CULLED, handleCulled); // clear fullscreen


              dpr = _this.contextService.getDPR();
              _this$canvasConfig = _this.canvasConfig, width = _this$canvasConfig.width, height = _this$canvasConfig.height;
              context = _this.contextService.getContext();

              _this.clearRect(context, 0, 0, width * dpr, height * dpr);

              fromScaling(_this.dprMatrix, fromValues(dpr, dpr, 1));

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
    renderingService.hooks.destroy.tap(CanvasRendererPlugin_1.tag, function () {
      _this.renderingContext.root.removeEventListener(ElementEvent.UNMOUNTED, handleUnmounted);

      _this.renderingContext.root.removeEventListener(ElementEvent.CULLED, handleCulled);
    });
    renderingService.hooks.beginFrame.tap(CanvasRendererPlugin_1.tag, function () {
      var context = _this.contextService.getContext();

      var dpr = _this.contextService.getDPR();

      var _this$canvasConfig2 = _this.canvasConfig,
          width = _this$canvasConfig2.width,
          height = _this$canvasConfig2.height; // some heuristic conditions such as 80% object changed

      var _renderingService$get = renderingService.getStats(),
          total = _renderingService$get.total,
          rendered = _renderingService$get.rendered;

      var ratio = rendered / total;
      _this.clearFullScreen = renderingService.disableDirtyRectangleRendering() || rendered > 100 && ratio > 0.8;

      if (context) {
        if (_this.clearFullScreen) {
          context.resetTransform();

          _this.clearRect(context, 0, 0, width * dpr, height * dpr);
        }
      }
    }); // render at the end of frame

    renderingService.hooks.endFrame.tap(CanvasRendererPlugin_1.tag, function () {
      var context = _this.contextService.getContext(); // clear & clip dirty rectangle


      multiply(_this.vpMatrix, _this.dprMatrix, _this.camera.getOrthoMatrix());

      if (_this.clearFullScreen) {
        _this.renderingContext.root.forEach(function (object) {
          if (object.isVisible() && !object.isCulled()) {
            _this.renderDisplayObject(object, renderingService);
          }
        });
      } else {
        // merge removed AABB
        var dirtyRenderBounds = _this.safeMergeAABB.apply(_this, [_this.mergeDirtyAABBs(_this.renderQueue)].concat(_this.removedRBushNodeAABBs.map(function (_ref2) {
          var minX = _ref2.minX,
              minY = _ref2.minY,
              maxX = _ref2.maxX,
              maxY = _ref2.maxY;
          var aabb = new AABB();
          aabb.setMinMax(fromValues(minX, minY, 0), fromValues(maxX, maxY, 0));
          return aabb;
        })));

        _this.removedRBushNodeAABBs = [];

        if (AABB.isEmpty(dirtyRenderBounds)) {
          _this.renderQueue = [];
          return;
        }

        var _this$convertAABB2Rec = _this.convertAABB2Rect(dirtyRenderBounds),
            x = _this$convertAABB2Rec.x,
            y = _this$convertAABB2Rec.y,
            width = _this$convertAABB2Rec.width,
            height = _this$convertAABB2Rec.height; // @see https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Transformations


        context.setTransform(_this.vpMatrix[0], _this.vpMatrix[1], _this.vpMatrix[4], _this.vpMatrix[5], _this.vpMatrix[12], _this.vpMatrix[13]);
        context.save();

        _this.clearRect(context, x, y, width, height);

        context.beginPath();
        context.rect(x, y, width, height);
        context.clip(); // draw dirty rectangle
        // if (enableDirtyRectangleRenderingDebug) {
        //   context.lineWidth = 4;
        //   context.strokeStyle = `rgba(${Math.random() * 255}, ${Math.random() * 255}, ${
        //     Math.random() * 255
        //   }, 1)`;
        //   context.strokeRect(x, y, width, height);
        // }
        // search objects intersect with dirty rectangle

        var dirtyObjects = _this.searchDirtyObjects(dirtyRenderBounds); // do rendering


        dirtyObjects // sort by z-index
        .sort(function (a, b) {
          return a.sortable.renderOrder - b.sortable.renderOrder;
        }).forEach(function (object) {
          // culled object should not be rendered
          if (object && object.isVisible() && !object.isCulled()) {
            _this.renderDisplayObject(object, renderingService);
          }
        });
        context.restore(); // save dirty AABBs in last frame

        _this.renderQueue.forEach(function (object) {
          _this.saveDirtyAABB(object);
        }); // clear queue


        _this.renderQueue = [];
      } // pop restore stack, eg. root -> parent -> child


      _this.restoreStack.forEach(function () {
        context.restore();
      }); // clear restore stack


      _this.restoreStack = [];
      _this.clearFullScreen = false;
    });
    renderingService.hooks.render.tap(CanvasRendererPlugin_1.tag, function (object) {
      if (!_this.clearFullScreen) {
        // render at the end of frame
        _this.renderQueue.push(object);
      }
    });
  };

  _proto.clearRect = function clearRect(context, x, y, width, height) {
    context.clearRect(x, y, width, height);
    var background = this.canvasConfig.background;

    if (background) {
      context.fillStyle = background;
      context.fillRect(x, y, width, height);
    }
  };

  _proto.renderDisplayObject = function renderDisplayObject(object, renderingService) {
    var context = this.contextService.getContext(); // restore to its parent

    var parent = this.restoreStack[this.restoreStack.length - 1];

    while (parent && object.parentNode !== parent) {
      context.restore();
      this.restoreStack.pop();
      parent = this.restoreStack[this.restoreStack.length - 1];
    }

    var nodeName = object.nodeName;

    if (this.styleRendererFactoryCache[nodeName] === undefined) {
      this.styleRendererFactoryCache[nodeName] = this.styleRendererFactory(nodeName);
    }

    var styleRenderer = this.styleRendererFactoryCache[nodeName];

    if (this.pathGeneratorFactoryCache[nodeName] === undefined) {
      this.pathGeneratorFactoryCache[nodeName] = this.pathGeneratorFactory(nodeName);
    }

    var generatePath = this.pathGeneratorFactoryCache[nodeName]; // clip path

    var clipPathShape = object.parsedStyle.clipPath;

    if (clipPathShape) {
      this.applyWorldTransform(context, clipPathShape, object.getWorldTransform()); // generate path in local space

      if (this.pathGeneratorFactoryCache[clipPathShape.nodeName] === undefined) {
        this.pathGeneratorFactoryCache[clipPathShape.nodeName] = this.pathGeneratorFactory(clipPathShape.nodeName);
      }

      var _generatePath = this.pathGeneratorFactoryCache[clipPathShape.nodeName];

      if (_generatePath) {
        context.save(); // save clip

        this.restoreStack.push(object);
        context.beginPath();

        _generatePath(context, clipPathShape.parsedStyle);

        context.closePath();
        context.clip();
      }
    } // fill & stroke


    if (styleRenderer) {
      this.applyWorldTransform(context, object);
      context.save(); // apply attributes to context

      this.applyAttributesToContext(context, object);
    }

    if (generatePath) {
      context.beginPath();
      generatePath(context, object.parsedStyle);

      if (object.nodeName !== Shape.LINE && object.nodeName !== Shape.PATH && object.nodeName !== Shape.POLYLINE) {
        context.closePath();
      }
    } // fill & stroke


    if (styleRenderer) {
      styleRenderer.render(context, object.parsedStyle, object, renderingService); // restore applied attributes, eg. shadowBlur shadowColor...

      context.restore();
    } // finish rendering, clear dirty flag


    object.renderable.dirty = false;
  };

  _proto.convertAABB2Rect = function convertAABB2Rect(aabb) {
    var min = aabb.getMin();
    var max = aabb.getMax(); // expand the rectangle a bit to avoid artifacts
    // @see https://www.yuque.com/antv/ou292n/bi8nix#ExvCu

    var minX = Math.floor(min[0]);
    var minY = Math.floor(min[1]);
    var maxX = Math.ceil(max[0]);
    var maxY = Math.ceil(max[1]);
    var width = maxX - minX;
    var height = maxY - minY;
    return {
      x: minX,
      y: minY,
      width: width,
      height: height
    };
  }
  /**
   * TODO: merge dirty rectangles with some strategies.
   * For now, we just simply merge all the rectangles into one.
   * @see https://idom.me/articles/841.html
   */
  ;

  _proto.mergeDirtyAABBs = function mergeDirtyAABBs(dirtyObjects) {
    // merge into a big AABB
    var aabb = new AABB();
    dirtyObjects.forEach(function (object) {
      var renderBounds = object.getRenderBounds();
      aabb.add(renderBounds);
      var dirtyRenderBounds = object.renderable.dirtyRenderBounds;

      if (dirtyRenderBounds) {
        aabb.add(dirtyRenderBounds);
      }
    });
    return aabb;
  };

  _proto.searchDirtyObjects = function searchDirtyObjects(dirtyRectangle) {
    var _this2 = this;

    // search in r-tree, get all affected nodes
    var _dirtyRectangle$getMi = dirtyRectangle.getMin(),
        minX = _dirtyRectangle$getMi[0],
        minY = _dirtyRectangle$getMi[1];

    var _dirtyRectangle$getMa = dirtyRectangle.getMax(),
        maxX = _dirtyRectangle$getMa[0],
        maxY = _dirtyRectangle$getMa[1];

    var rBushNodes = this.rBush.search({
      minX: minX,
      minY: minY,
      maxX: maxX,
      maxY: maxY
    });
    return rBushNodes.map(function (_ref3) {
      var id = _ref3.id;
      return _this2.displayObjectPool.getByEntity(id);
    });
  };

  _proto.saveDirtyAABB = function saveDirtyAABB(object) {
    var renderable = object.renderable;

    if (!renderable.dirtyRenderBounds) {
      renderable.dirtyRenderBounds = new AABB();
    }

    var renderBounds = object.getRenderBounds();

    if (renderBounds) {
      // save last dirty aabb
      renderable.dirtyRenderBounds.update(renderBounds.center, renderBounds.halfExtents);
    }
  }
  /**
   * TODO: batch the same global attributes
   */
  ;

  _proto.applyAttributesToContext = function applyAttributesToContext(context, object) {
    var _object$parsedStyle = object.parsedStyle,
        stroke = _object$parsedStyle.stroke,
        fill = _object$parsedStyle.fill,
        opacity = _object$parsedStyle.opacity,
        lineDash = _object$parsedStyle.lineDash,
        lineDashOffset = _object$parsedStyle.lineDashOffset,
        filter = _object$parsedStyle.filter,
        shadowColor = _object$parsedStyle.shadowColor,
        shadowBlur = _object$parsedStyle.shadowBlur,
        shadowOffsetX = _object$parsedStyle.shadowOffsetX,
        shadowOffsetY = _object$parsedStyle.shadowOffsetY; // @see https://developer.mozilla.org/zh-CN/docs/Web/API/CanvasRenderingContext2D/setLineDash

    if (lineDash && Array.isArray(lineDash)) {
      context.setLineDash(lineDash.map(function (segment) {
        return segment.value;
      }));
    } // @see https://developer.mozilla.org/zh-CN/docs/Web/API/CanvasRenderingContext2D/lineDashOffset


    if (!isNil(lineDashOffset)) {
      context.lineDashOffset = lineDashOffset.value;
    }

    if (!isNil(opacity)) {
      context.globalAlpha *= opacity.value;
    }

    if (!isNil(stroke) && !Array.isArray(stroke) && !stroke.isNone) {
      context.strokeStyle = object.attributes.stroke;
    }

    if (!isNil(fill) && !Array.isArray(fill) && !fill.isNone) {
      context.fillStyle = object.attributes.fill;
    }

    if (!isNil(filter)) {
      // use raw filter string
      context.filter = object.style.filter;
    }

    var hasShadow = !isNil(shadowColor) && (shadowBlur === null || shadowBlur === void 0 ? void 0 : shadowBlur.value) > 0;

    if (hasShadow) {
      context.shadowColor = shadowColor.toString();
      context.shadowBlur = shadowBlur && shadowBlur.value || 0;
      context.shadowOffsetX = shadowOffsetX && shadowOffsetX.value || 0;
      context.shadowOffsetY = shadowOffsetY && shadowOffsetY.value || 0;
    }
  };

  _proto.applyWorldTransform = function applyWorldTransform(context, object, matrix) {
    var tx = 0;
    var ty = 0;

    var _ref4 = object.parsedStyle || {},
        anchor = _ref4.anchor;

    var anchorX = anchor && anchor[0].value || 0;
    var anchorY = anchor && anchor[1].value || 0;

    if (anchorX !== 0 || anchorY !== 0) {
      var bounds = object.getGeometryBounds();
      var width = bounds && bounds.halfExtents[0] * 2 || 0;
      var height = bounds && bounds.halfExtents[1] * 2 || 0;
      tx = -(anchorX * width);
      ty = -(anchorY * height);
    } // apply clip shape's RTS


    if (matrix) {
      copy(this.tmpMat4, object.getLocalTransform());
      this.tmpVec3[0] = tx;
      this.tmpVec3[1] = ty;
      this.tmpVec3[2] = 0;
      translate(this.tmpMat4, this.tmpMat4, this.tmpVec3);
      multiply(this.tmpMat4, matrix, this.tmpMat4);
      multiply(this.tmpMat4, this.vpMatrix, this.tmpMat4);
    } else {
      // apply RTS transformation in world space
      copy(this.tmpMat4, object.getWorldTransform());
      this.tmpVec3[0] = tx;
      this.tmpVec3[1] = ty;
      this.tmpVec3[2] = 0;
      translate(this.tmpMat4, this.tmpMat4, this.tmpVec3);
      multiply(this.tmpMat4, this.vpMatrix, this.tmpMat4);
    } // @see https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Transformations


    context.setTransform(this.tmpMat4[0], this.tmpMat4[1], this.tmpMat4[4], this.tmpMat4[5], this.tmpMat4[12], this.tmpMat4[13]);
  };

  _proto.safeMergeAABB = function safeMergeAABB() {
    var merged = new AABB();

    for (var _len = arguments.length, aabbs = new Array(_len), _key = 0; _key < _len; _key++) {
      aabbs[_key] = arguments[_key];
    }

    aabbs.forEach(function (aabb) {
      merged.add(aabb);
    });
    return merged;
  };

  return CanvasRendererPlugin;
}(), _class.tag = 'CanvasRenderer', _class);

__decorate([inject(CanvasConfig), __metadata("design:type", Object)], CanvasRendererPlugin.prototype, "canvasConfig", void 0);

__decorate([inject(DefaultCamera), __metadata("design:type", Camera)], CanvasRendererPlugin.prototype, "camera", void 0);

__decorate([inject(ContextService), __metadata("design:type", Object)], CanvasRendererPlugin.prototype, "contextService", void 0);

__decorate([inject(RenderingContext), __metadata("design:type", Object)], CanvasRendererPlugin.prototype, "renderingContext", void 0);

__decorate([inject(PathGeneratorFactory), __metadata("design:type", Function)], CanvasRendererPlugin.prototype, "pathGeneratorFactory", void 0);

__decorate([inject(StyleRendererFactory), __metadata("design:type", Function)], CanvasRendererPlugin.prototype, "styleRendererFactory", void 0);

__decorate([inject(DisplayObjectPool), __metadata("design:type", DisplayObjectPool)], CanvasRendererPlugin.prototype, "displayObjectPool", void 0);

__decorate([inject(RBushRoot), __metadata("design:type", RBush)], CanvasRendererPlugin.prototype, "rBush", void 0);

CanvasRendererPlugin = CanvasRendererPlugin_1 = __decorate([singleton({
  contrib: RenderingPluginContribution
})], CanvasRendererPlugin);

var containerModule = Module(function (register) {
  var _shape2Token;

  register(CircleRenderer);
  register(EllipseRenderer);
  register(RectRenderer);
  register(ImageRenderer);
  register(TextRenderer);
  register(LineRenderer);
  register(PolylineRenderer);
  register(PolygonRenderer);
  register(PathRenderer);
  var shape2Token = (_shape2Token = {}, _shape2Token[Shape.CIRCLE] = CircleRendererContribution, _shape2Token[Shape.ELLIPSE] = EllipseRendererContribution, _shape2Token[Shape.RECT] = RectRendererContribution, _shape2Token[Shape.IMAGE] = ImageRendererContribution, _shape2Token[Shape.TEXT] = TextRendererContribution, _shape2Token[Shape.LINE] = LineRendererContribution, _shape2Token[Shape.POLYLINE] = PolylineRendererContribution, _shape2Token[Shape.POLYGON] = PolygonRendererContribution, _shape2Token[Shape.PATH] = PathRendererContribution, _shape2Token);
  register({
    token: StyleRendererFactory,
    useFactory: function useFactory(ctx) {
      return function (tagName) {
        var token = shape2Token[tagName];

        if (token && ctx.container.isBound(token)) {
          return ctx.container.get(token);
        }

        return null;
      };
    }
  });
  register(CanvasRendererPlugin);
});
var Plugin = /*#__PURE__*/function () {
  function Plugin() {
    this.name = 'canvas-renderer';
  }

  var _proto = Plugin.prototype;

  _proto.init = function init(container) {
    container.load(containerModule, true);
  };

  _proto.destroy = function destroy(container) {
    container.unload(containerModule);
  };

  return Plugin;
}();

export { CircleRenderer, CircleRendererContribution, EllipseRenderer, EllipseRendererContribution, ImageRenderer, ImageRendererContribution, LineRenderer, LineRendererContribution, PathRenderer, PathRendererContribution, Plugin, PolygonRenderer, PolygonRendererContribution, PolylineRenderer, PolylineRendererContribution, RectRenderer, RectRendererContribution, StyleRendererFactory, TextRenderer, TextRendererContribution };
